
; *** initialize the kernel loop: ***

; From here on in to .ExitKernel this is all Thomas Jentzsch and	it's a complete work of art.
;
;	lda	MaskTbl+TOMBSTONE_ROWS-1 ; 4
	lda	#%01010101
	and	Data_PF_Left+TOMBSTONE_ROWS-1		; 4
	sta	Temp_PF_Left				; 3
	lda	Data_PF_Right+TOMBSTONE_ROWS-1		; 4
	sta	Temp_PF_Right				; 3 = 18

	;lda	#0			 		; 2
	;sta	COLUP0		 			; 3
	;sta	COLUP1		 			; 3 =  8

	nop
	nop
	nop
	nop

;BEGIN FIX

	ldy	#KERNEL_HEIGHT-2 			; 2 =  4

	cpy	Gremlin1_Y_Temp				; 3
	bpl	.skipEnableM1				; 2
	lda	Gremlin1_Y				; 3
	sta	Gremlin1_Y_Temp				; 3
	iny
	cpy	Gremlin1_Y_Temp				; 3
	bpl	.skipEnableM1a  			; 2
	lda	#2				 	; 2
	; lda	#0
	sta	 ENAM1			 		; 3
.skipEnableM1a
	dey
.skipEnableM1:
	iny

	cpy	Gremlin0_Y_Temp				; 3
	bpl	.skipEnableM0				; 2
	lda	Gremlin0_Y				; 3
	sta	Gremlin0_Y_Temp				; 3
	lda	#2				 	; 2
	sta	ENAM0			 		; 3
.skipEnableM0:
;END OF FIX


	iny						; 2
	ldx	#TOMBSTONE_ROWS-1			; 2 =  4

; draw Car #1:
	lda	#CAR_HEIGHT-1				; 2
	cmp	Car1_Y					; 3
	bcs	.doDraw1				; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw1:
	lda	(Car1_Pointer),y	 		; 5
	sta	GRP1					; 3 = 16

	lda	#CAR_HEIGHT-1				; 2
	cmp	Car0_Y					; 3
	bcs	.doDraw0				; 2
	lda	#0					; 2
	BIT_W						;-1
.doDraw0:
	lda	(Car0_Pointer),y	 		; 5
	sta	GRP0					; 3 = 16

	dey						; 2 =  2

; draw Car #1:
	lda	#CAR_HEIGHT-1				; 2
	dcp	Car1_Y					; 5
	bcs	.doDraw1_a	 			; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw1_a:
	lda	(Car1_Pointer),y	 		; 5
	sta	GRP1					; 3 = 18

	lda	Ball_Control	 			; 3
	asl						; 2 =  5
  
  ;end border
	sta	ENABL					; 3 =  3			VDELed
	
	lda	#$0F

	sta	WSYNC
	sta	COLUPF

;---------------------------------------


  ; lda	#CAR1_COLOR					; 2
	;sta	COLUP1		 			; 3
	;lda	#CAR0_COLOR				; 2
  ; sta	COLUP0		 				; 3
	
	nop
	nop
	nop
	nop
	nop
	
	
	lda	#$90					; 2				enable left and	right borders
	sta	PF0					; 3

	jmp	EnterKernel				; 3 = 18	@21
;***************************************

	align	256

; wasting some bytes to avoid page penalties:
	ds	 $74, 0

Kernel SUBROUTINE

.disableM1:						; 9
	SLEEP	2					; 2				waste two cycles for constant timing
	lda	#DISABLE_BM				; 2
	beq	.continueM1a				;10

.checkM1:						; 6
	bne	.disableM1	 			; 2
;.enableM1:
	lda	Gremlin1_Y				; 3
	sta	Gremlin1_Y_Temp				; 3
	lda	#ENABLE_BM	 			; 2
.continueM1a:
	sta.w	ENAM1					; 4		@00	(>= @00)
	bpl	.continueM1				; 3

.disableM0:						; 8
	SLEEP	2					; 5				waste two cycles for constant timing
	lda	#DISABLE_BM				; 2
	beq	.continueM0a				; 9

.checkM0:						; 6
	bne	.disableM0	 			; 2
;.enableM0:
	lda	Gremlin0_Y				; 3
	sta	Gremlin0_Y_Temp				; 3
	lda	#ENABLE_BM	 			; 2
.continueM0a:
	sta.w	ENAM0					; 4		@01	(>= @00)
	bpl	.continueM0				; 3

;***************************************


; cycle count (tombstone row):
; - loop overhead			 9
; - COLUPF			   5 =	 5
; - playfield			29+8 =  37
; - players			18*2 =  36
; - missiles/HMOVE  		23*2 =  46
; - HMCLR			3*2  =	 6
; - free			4+9  =  13
;				----------------
; Total				76*2 = 152 :-)

.contBlock:						;			@42
	SLEEP	9					; 9
	asl						; 2 = 11

.nextBlock:
	sta	COLUPF		 			; 3 =  3	@56	too early for 2nd row of ball

; draw Gremlin #1:
	cpy	Gremlin1_Y_Temp				; 3
	bpl	.checkM1				; 2
;.drawM1:
	lda	(Gremlin1_Pointer),y	 		; 5
	sta	HMM1					; 3
	asl						; 2
	asl						; 2
	sta	HMOVE					; 3		@00	three cycles too early, ok
;---------------------------------------
	sta	NUSIZ1		 			; 3		@03	(>= @00)
.continueM1:						;	= 23			timing is constant!

; draw Car #1:
	lda	#CAR_HEIGHT-1				; 2
	dcp	Car1_Y					; 5
	bcs	.doDraw1				; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw1:
	lda	(Car1_Pointer),y	 		; 5
	sta	GRP1					; 3 = 18	@21
EnterKernel:			 ;

; draw tomstones (part 1/2):
	lda	Temp_PF_Left				; 3
	sta	PF1					; 3		@27	(<= @27)
	eor	Data_PF_Left,x	 			; 4
	sta	PF2					; 3		@34	(<= @38)

	SLEEP	4					; 4

; draw tomstones (part 2/2):
	lda	MaskTbl,x				; 4
	and	Temp_PF_Right				; 3
	sta	PF2					; 3		@48	(== @48)
	eor	Temp_PF_Right				; 3
	sta	PF1					; 3		@54	(<= @54)

; clear all hmov registers:
	sta	HMCLR					; 3 =  3	@57

; draw Gremlin #0:
	cpy	Gremlin0_Y_Temp				; 3
	bpl	.checkM0				; 2
;.drawM0:
	lda	(Gremlin0_Pointer),y			; 5
	sta	HMM0					; 3
	asl						; 2
	asl						; 2
;---------------------------------------
	sta	HMOVE					; 3		@01	two cycles too early, ok
	sta	NUSIZ0		 			; 3		@04	(>= @00)
.continueM0:						;	= 23			timing is constant!

; draw Car #0:
	lda	#CAR_HEIGHT-1				; 2
	dcp	Car0_Y					; 5
	bcs	.doDraw0				; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw0:
	lda	(Car0_Pointer),y	 		; 5
	sta	GRP0					; 3 = 18	@22

; disable playfield:
	lda	#0			 		; 2
	sta	PF1					; 3		@27	(<= @27)
	sta	PF2					; 3 =  8	@30	(<= @38)

; clear all hmov registers:
	sta	HMCLR					; 3 =  3	@33

; tombstone indexer routine (part 1/2):
	dey						; 2
	tya						; 2
	and	#7			 		; 2
	bne	.contBlock	 			; 2=  8

	SLEEP	5					; 5 =  5

; draw grenade:
	lda	#ENABLE_BM	 			; 2
	cpx	Ball_Row	 			; 3
	beq	.enableBL				; 2
	BIT_W						; 1
.enableBL:
	sta	ENABL					; 3 = 11	@57	VDELed!

; draw Gremlin #1:
	cpy	Gremlin1_Y_Temp				; 3
	bpl	.checkGremlin1_a	 		; 2
;.drawGremlin1_a:
	lda	(Gremlin1_Pointer),y	 		; 5
	sta	HMM1					; 3
	asl						; 2
	asl						; 2
;---------------------------------------
	sta	HMOVE					; 3		@01	two cycles too early, ok
	sta	NUSIZ1		 			; 3		@04	(>= @00)
.continueGremlin1_a:			 		;	= 23			timing is constant!

; draw Car #1:
	lda	#CAR_HEIGHT-1				; 2
	dcp	Car1_Y					; 5
	bcs	.doDraw1_a	 			; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw1_a:
	lda	(Car1_Pointer),y	 		; 5
	sta	GRP1					; 3 = 18	@22

; set grenade color and	clear PF0:
	lda	Ball_Control				; 3
	sta	COLUPF		 			; 3		@28
	stx	PF0					; 3 =  9	@31	clear PF0 (bits 0..3: don't Care)

; prepare tombstone row:
	lda	MaskTbl-1,x				; 4
	and	Data_PF_Left-1,x			; 4
	sta	Temp_PF_Left				; 3
	lda	Data_PF_Right-1,x			; 4
	sta	Temp_PF_Right				; 3 = 18

	SLEEP	4					; 4 =  4

; clear all hmov registers:
	sta	HMCLR					; 3 =  3	@56

; draw Gremlin #0:
	cpy	Gremlin0_Y_Temp				; 3
	bpl	.checkGremlin0_a	 		; 2
;.drawGremlin0_a:
	lda	(Gremlin0_Pointer),y	 		; 5
	sta	HMM0					; 3
	asl						; 2
	asl						; 2
	sta	HMOVE					; 3		@75	four cycles too early, (just!) ok
;---------------------------------------
	sta	NUSIZ0		 			; 3		@03	(>= @00)
.continueGremlin0_a:			 		;	= 23			timing is constant!

; draw Car #0:
	lda	#CAR_HEIGHT-1				; 2
	dcp	Car0_Y					; 5
	bcs	.doDraw0_a	 			; 2
	lda	#0			 		; 2
	BIT_W						;-1
.doDraw0_a:
	lda	(Car0_Pointer),y	 		; 5
	sta	GRP0					; 3 = 18	@21

; set color for second ball row:
	lda	#$0e					; 2
	sta	COLUPF		 			; 3 =  5	@26	(<= @27)

; tombstone indexer routine (part 2/2):
	dex						; 2
	bmi	.exitLoop				; 2=  4

; disable grenade:
	lda	Ball_Control	 			; 3
	asl						; 2
	sta	ENABL					; 3		@38	VDELed!
	lda	#$90					; 2
	sta	PF0					; 3 = 13	@43

; clear all hmov registers:
	sta	HMCLR					; 3 =  3	@46

; TombstoneIndexer routine:
	dey						; 2
	lda	#$0e					; 2
	jmp	.nextBlock	 			; 3 =  7

.exitLoop:
	jmp	ExitKernel
;***************************************

.disableGremlin1_a:					; 9
	SLEEP	2					; 2				waste two cycles for constant timing
	lda	#DISABLE_BM				; 2
	beq	.continueM1a_a  			;10

.checkGremlin1_a:					; 6
	bne	.disableGremlin1_a			; 2
;.enableGremlin1_a:
	lda	Gremlin1_Y				; 3
	sta	Gremlin1_Y_Temp  			; 3
	lda	#ENABLE_BM	 			; 2
.continueM1a_a:
;---------------------------------------
	sta.w	ENAM1					; 4		@01	(>= @00)
	bpl	.continueGremlin1_a			; 3

.disableGremlin0_a:					; 8
	SLEEP	2					; 5				waste two cycles for constant timing
	lda	#DISABLE_BM				; 2
	beq	.continueM0a_a  			; 9

.checkGremlin0_a:					; 6
	bne	.disableGremlin0_a			; 2
;.enableGremlin0_a:
	lda	Gremlin0_Y				; 3
	sta	Gremlin0_Y_Temp  			; 3
	lda	#ENABLE_BM	 			; 2
.continueM0a_a:
;---------------------------------------
	sta.w	ENAM0					; 4		@02	(>= @00)
	bpl	.continueGremlin0_a			; 3
;***************************************
;end of Thomas Jentzsch's miracle kernel


